%if 0%{?fedora}
# https://bugzilla.redhat.com/show_bug.cgi?id=1217563
# NOTE: BoneCP SHOULD NOW BE CONSIDERED DEPRECATED in favour of HikariCP
%bcond_with bonecp
%endif

Name:          qpid-java
Version:       6.0.4
Release:       7%{?dist}
Summary:       Apache Qpid Java Components
License:       ASL 2.0
URL:           http://qpid.apache.org/components/
Source0:       http://www.apache.org/dist/qpid/java/%{version}/%{name}-%{version}.tar.gz
# https://issues.apache.org/jira/browse/QPID-7599
Patch0:        qpid-java-6.0.4-CVE-2016-8741.patch

BuildRequires: maven-local
BuildRequires: mvn(ch.qos.logback:logback-classic)
BuildRequires: mvn(com.fasterxml.jackson.core:jackson-core)
BuildRequires: mvn(com.fasterxml.jackson.core:jackson-databind)
BuildRequires: mvn(com.google.guava:guava)
%if %{with bonecp}
BuildRequires: mvn(com.jolbox:bonecp)
%endif
BuildRequires: mvn(com.sleepycat:je)
BuildRequires: mvn(commons-cli:commons-cli)
BuildRequires: mvn(javax.servlet:javax.servlet-api)
BuildRequires: mvn(junit:junit)
BuildRequires: mvn(net.sourceforge.csvjdbc:csvjdbc)
BuildRequires: mvn(org.apache:apache:pom:)
BuildRequires: mvn(org.apache.bcel:bcel)
BuildRequires: mvn(org.apache.derby:derby)
BuildRequires: mvn(org.apache.geronimo.specs:geronimo-ejb_3.1_spec)
BuildRequires: mvn(org.apache.geronimo.specs:geronimo-jms_1.1_spec)
BuildRequires: mvn(org.apache.geronimo.specs:geronimo-jta_1.1_spec)
BuildRequires: mvn(org.apache.maven.plugins:maven-antrun-plugin)
# BuildRequires: mvn(org.apache.maven.plugins:maven-deploy-plugin)
BuildRequires: mvn(org.apache.maven.plugins:maven-enforcer-plugin)
BuildRequires: mvn(org.apache.maven.plugins:maven-remote-resources-plugin)
BuildRequires: mvn(org.apache.velocity:velocity)
BuildRequires: mvn(org.codehaus.mojo:buildnumber-maven-plugin)
BuildRequires: mvn(org.codehaus.mojo:exec-maven-plugin)
BuildRequires: mvn(org.codehaus.mojo:javacc-maven-plugin)
BuildRequires: mvn(org.eclipse.jetty:jetty-server:8.1)
BuildRequires: mvn(org.eclipse.jetty:jetty-servlet:8.1)
BuildRequires: mvn(org.eclipse.jetty:jetty-websocket:8.1)
BuildRequires: mvn(org.jboss.spec.javax.resource:jboss-connector-api_1.7_spec)
BuildRequires: mvn(org.jfree:jfreechart)
BuildRequires: mvn(org.python:jython)
BuildRequires: mvn(org.mockito:mockito-all)
BuildRequires: mvn(org.slf4j:slf4j-api)
BuildRequires: subversion

BuildArch:     noarch

%description
Qpid Java offers an AMQP-fluent implementation of JMS and
a message broker written in Java that stores, routes, and
forwards messages using AMQP.

%package -n qpid-bdbstore
Summary:       Qpid BDB Message Store

%description -n qpid-bdbstore
BDB message store implementation using Oracle Berkeley DB Java Edition.

%package -n qpid-bdbstore-jmx
Summary:       Qpid BDB Message Store JMX

%description -n qpid-bdbstore-jmx
BDB message store JMX implementation.

%package -n qpid-broker
Summary:       Qpid Java Broker

%description -n qpid-broker
Broker configuration and executable.

%package -n qpid-broker-codegen
Summary:       Qpid Broker Code Generation

%description -n qpid-broker-codegen
Code Generation For Broker and Plugins.

%package -n qpid-broker-core
Summary:       Qpid Java Broker Core

%description -n qpid-broker-core
Broker core functionality and initial configuration.

%package -n qpid-broker-plugins-access-control
Summary:       Qpid Access Control Broker Plug-in

%description -n qpid-broker-plugins-access-control
Qpid Access Control broker plug-in.

%package -n qpid-broker-plugins-amqp-0-8-protocol
Summary:       Qpid AMQP 0-8 Protocol Broker Plug-in

%description -n qpid-broker-plugins-amqp-0-8-protocol
Qpid AMQP 0-8, 0-9 and 0-9-1 protocol broker plug-in.

%package -n qpid-broker-plugins-amqp-0-10-protocol
Summary:       Qpid AMQP 0-10 Protocol Broker Plug-in

%description -n qpid-broker-plugins-amqp-0-10-protocol
Qpid AMQP 0-10 protocol broker plug-in.

%package -n qpid-broker-plugins-amqp-1-0-protocol
Summary:       Qpid AMQP 1-0 Protocol Broker Plug-in

%description -n qpid-broker-plugins-amqp-1-0-protocol
Qpid AMQP 1-0 protocol broker plug-in.

%package -n qpid-broker-plugins-amqp-msg-conv-0-8-to-0-10
Summary:       Qpid AMQP 0-8 to 0-10 Message Conversion Broker Plug-in

%description -n qpid-broker-plugins-amqp-msg-conv-0-8-to-0-10
Qpid AMQP message conversion (0-8, 0-9 and 0-9-1 to 0-10) broker plug-in.

%package -n qpid-broker-plugins-amqp-msg-conv-0-8-to-1-0
Summary:       Qpid AMQP 0-8 to 1-0 Message Conversion Broker Plug-in

%description -n qpid-broker-plugins-amqp-msg-conv-0-8-to-1-0
Qpid AMQP message conversion (0-8, 0-9 and 0-9-1 to 1-0) broker plug-in.

%package -n qpid-broker-plugins-amqp-msg-conv-0-10-to-1-0
Summary:       Qpid AMQP 0-10 to 1-0 Message Conversion Broker Plug-in

%description -n qpid-broker-plugins-amqp-msg-conv-0-10-to-1-0
Qpid AMQP message conversion (0-10 to 1-0) broker plug-in.

%package -n qpid-broker-plugins-derby-store
Summary:       Qpid Derby Message Store

%description -n qpid-broker-plugins-derby-store
Apache Derby DB message store broker plug-in.

%package -n qpid-broker-plugins-jdbc-provider-bone
Summary:       Qpid JDBC Message Store Connection Pooling Plug-in

%description -n qpid-broker-plugins-jdbc-provider-bone
JDBC Message Store Connection Pooling broker plug-in using BoneCP.

%package -n qpid-broker-plugins-jdbc-store
Summary:       Qpid JDBC Message Store Broker Plug-in

%description -n qpid-broker-plugins-jdbc-store
Qpid JDBC message store broker plug-in.

%package -n qpid-broker-plugins-management-amqp
Summary:       Qpid AMQP Management Protocol Broker Plug-in

%description -n qpid-broker-plugins-management-amqp
Qpid AMQP Management broker plug-in.

%if 0
%package -n qpid-broker-plugins-management-http
Summary:       Qpid HTTP Management Broker Plug-in
# MIT https://code.google.com/archive/p/crypto-js/
License:       ASL 2.0 and MIT
# BuildRequires: dojo >= 1.10.3
# Requires:      dojo >= 1.10.3
Provides:      bundled(crypto-js) = 3.1.2

%description -n qpid-broker-plugins-management-http
Qpid HTTP Management broker plug-in.
%endif

%package -n qpid-broker-plugins-management-jmx
Summary:       Qpid JMX Management Broker Plug-in

%description -n qpid-broker-plugins-management-jmx
Qpid JMX management broker plug-in.

%package -n qpid-broker-plugins-memory-store
Summary:       Qpid Memory Message Store Broker Plug-in

%description -n qpid-broker-plugins-memory-store
Qpid Memory message store broker plug-in.

%package -n qpid-broker-plugins-websocket
Summary:       Qpid WebSocket Broker Plug-in

%description -n qpid-broker-plugins-websocket
Qpid WebSocket broker plug-in.

%package build
Summary:       Qpid Java Build POM

%description build
Apache Qpid Java Components Build POM.

%package -n qpid-client
Summary:       Qpid AMQP 0-x JMS Client

%description -n qpid-client
JMS client supporting AMQP 0-8, 0-9, 0-9-1 and 0-10.

%package -n qpid-client-examples
Summary:       Qpid AMQP 0-x JMS Client Examples

%description -n qpid-client-examples
JMS client examples.

%package -n qpid-common
Summary:       Qpid Common

%description -n qpid-common
Qpid Common functionality.

%package -n qpid-jca
Summary:       Qpid JCA Resource Adapter

%description -n qpid-jca
The Qpid Resource Adapter is a JCA 1.5 compliant resource adapter that allows
for JEE integration between EE applications and AMQP 0.10  message brokers.

%package -n qpid-management-common
Summary:       Qpid Management Common

%description -n qpid-management-common
Qpid Common management code.

%package -n qpid-management-examples
Summary:       Qpid Management Examples

%description -n qpid-management-examples
Qpid Example management code.

%package -n qpid-perftests
Summary:       Qpid Performance Tests

%description -n qpid-perftests
Qpid Performance testing configuration, code and tests.

%package -n qpid-perftests-visualisation-jfc
Summary:       Qpid Performance Tests Visualisation JFC

%description -n qpid-perftests-visualisation-jfc
Performance testing visualisation using JFreeChart.

%package -n qpid-test-utils
Summary:       Qpid Test Utilities

%description -n qpid-test-utils
Qpid Testing utilities.

%package tools
Summary:       Qpid Tools

%description tools
Qpid Tools.

%package javadoc
Summary:       Javadoc for %{name}

%description javadoc
This package contains javadoc for %{name}.

%prep
%setup -q -n %{name}-%{version}
# Cleanup
find . -name "*.bat" -print -delete

%patch0 -p1

# Use com.agilejava.docbkx:docbkx-maven-plugin
%pom_disable_module doc

# Unsupported features
%pom_disable_module jca/rar

# Use org.fusesource.joram-jms-tests:joram-jms-tests:1.0
%pom_disable_module joramtests

%pom_change_dep :jfreechart org.jfree: perftests/visualisation-jfc

%if %{without bonecp}
%pom_disable_module broker-plugins/jdbc-provider-bone
%pom_remove_dep :qpid-broker-plugins-jdbc-provider-bone broker
%endif

%pom_disable_module broker-plugins/management-http
rm -r broker-plugins/management-http/src/main/java/resources/js/crypto-js
%pom_remove_dep :qpid-broker-plugins-management-http broker

# Use all above disabled modules
%pom_disable_module systests
# Only test
%pom_disable_module qpid-perftests-systests
%pom_disable_module qpid-systests-parent
%pom_disable_module bdbstore/systests

# Unwanted tasks
%pom_remove_plugin -r :jacoco-maven-plugin
%pom_remove_plugin -r :maven-assembly-plugin
%pom_remove_plugin -r :apache-rat-plugin

# Fix maven-antrun-plugin deps
# velocity:1.4
%pom_xpath_set pom:properties/pom:velocity-version 1.7
%pom_remove_dep :velocity-dep broker-core
%pom_change_dep :velocity org.apache.velocity: broker-core
# jython:2.5.3
%pom_xpath_set pom:properties/pom:jython-version 2.7
%pom_change_dep :jython-standalone :jython common

%pom_xpath_set pom:properties/pom:jetty-version 8.1

%pom_change_dep -r :geronimo-servlet_3.0_spec javax.servlet:javax.servlet-api:3.1.0
%pom_change_dep :geronimo-j2ee-connector_1.5_spec org.jboss.spec.javax.resource:jboss-connector-api_1.7_spec:1.0.0.Final jca
%pom_change_dep :geronimo-ejb_3.0_spec :geronimo-ejb_3.1_spec:1.0 jca
# org.apache.geronimo.framework:geronimo-kernel:2.2.1
%pom_remove_dep :geronimo-kernel jca
rm jca/src/main/java/org/apache/qpid/ra/tm/GeronimoTransactionManagerLocator.java


# AssertionFailedError: expected:<Mock for ServerMessage, hashCode: 6256704> but was:<null>
rm broker-core/src/test/java/org/apache/qpid/server/queue/SortedQueueTest.java
find ./broker-core -name "QueueMessageRecoveryTest.java" -print -delete
# ClassCastException: ch.qos.logback.core.Context$$EnhancerByMockitoWithCGLIB$$767a6196
# cannot be cast to ch.qos.logback.classic.LoggerContext
rm broker-core/src/test/java/org/apache/qpid/server/logging/AppenderUtilsTest.java \
 broker-core/src/test/java/org/apache/qpid/server/logging/StartupAppenderTest.java
# UnknownHostException: buildvm-13.phx2.fedoraproject.org: buildvm-13.phx2.fedoraproject.org: unknown error
rm broker-plugins/access-control/src/test/java/org/apache/qpid/server/security/access/plugins/DefaultAccessControlTest.java
# SSLHandshakeException: General SSLEngine problem
find ./common -name "SSLUtilTest.java" -print -delete
# AssertionFailedError: Last updated time by should be changed by update at org.apache.qpid.server.model.testmodels.singleton.AbstractConfiguredObjectTest.testAuditInformationIgnoresUserSuppliedAttributes(AbstractConfiguredObjectTest.java:817)
rm broker-core/src/test/java/org/apache/qpid/server/model/testmodels/singleton/AbstractConfiguredObjectTest.java

%build

%mvn_build -s -- -Pgenerate-sources-broker-core,generate-sources-common

%install
%mvn_install

%files -n qpid-bdbstore -f .mfiles-qpid-bdbstore
%files -n qpid-bdbstore-jmx -f .mfiles-qpid-bdbstore-jmx
%files -n qpid-broker -f .mfiles-qpid-broker
%files -n qpid-broker-codegen -f .mfiles-qpid-broker-codegen
%license LICENSE NOTICE

%files -n qpid-broker-core -f .mfiles-qpid-broker-core
%license LICENSE NOTICE

%files -n qpid-broker-plugins-access-control -f .mfiles-qpid-broker-plugins-access-control
%license LICENSE NOTICE

%files -n qpid-broker-plugins-amqp-0-8-protocol -f .mfiles-qpid-broker-plugins-amqp-0-8-protocol
%license LICENSE NOTICE

%files -n qpid-broker-plugins-amqp-0-10-protocol -f .mfiles-qpid-broker-plugins-amqp-0-10-protocol
%license LICENSE NOTICE

%files -n qpid-broker-plugins-amqp-1-0-protocol -f .mfiles-qpid-broker-plugins-amqp-1-0-protocol
%license LICENSE NOTICE

%files -n qpid-broker-plugins-amqp-msg-conv-0-8-to-0-10 -f .mfiles-qpid-broker-plugins-amqp-msg-conv-0-8-to-0-10
%files -n qpid-broker-plugins-amqp-msg-conv-0-8-to-1-0 -f .mfiles-qpid-broker-plugins-amqp-msg-conv-0-8-to-1-0
%files -n qpid-broker-plugins-amqp-msg-conv-0-10-to-1-0 -f .mfiles-qpid-broker-plugins-amqp-msg-conv-0-10-to-1-0
%files -n qpid-broker-plugins-derby-store -f .mfiles-qpid-broker-plugins-derby-store

%if %{with bonecp}
%files -n qpid-broker-plugins-jdbc-provider-bone -f .mfiles-qpid-broker-plugins-jdbc-provider-bone
%endif

%files -n qpid-broker-plugins-jdbc-store -f .mfiles-qpid-broker-plugins-jdbc-store
%license LICENSE NOTICE

%files -n qpid-broker-plugins-management-amqp -f .mfiles-qpid-broker-plugins-management-amqp
%license LICENSE NOTICE

%if 0
%files -n qpid-broker-plugins-management-http -f .mfiles-qpid-broker-plugins-management-http
%endif

%files -n qpid-broker-plugins-management-jmx -f .mfiles-qpid-broker-plugins-management-jmx
%files -n qpid-broker-plugins-memory-store -f .mfiles-qpid-broker-plugins-memory-store
%license LICENSE NOTICE

%files -n qpid-broker-plugins-websocket -f .mfiles-qpid-broker-plugins-websocket
%license LICENSE NOTICE

%files build -f .mfiles-qpid-java-build
%doc README.txt
%license LICENSE NOTICE

%files -n qpid-client -f .mfiles-qpid-client
%doc client/README.txt

%files -n qpid-client-examples -f .mfiles-qpid-client-examples
%doc client/example/README.txt

%files -n qpid-common -f .mfiles-qpid-common
%doc common/readme.txt
%license LICENSE NOTICE

%files -n qpid-jca -f .mfiles-qpid-jca
%doc jca/README*.txt
%license LICENSE NOTICE

%files -n qpid-management-common -f .mfiles-qpid-management-common
%license LICENSE NOTICE

%files -n qpid-management-examples -f .mfiles-qpid-management-examples
%license LICENSE NOTICE

%files -n qpid-perftests -f .mfiles-qpid-perftests

%files -n qpid-perftests-visualisation-jfc -f .mfiles-qpid-perftests-visualisation-jfc

%files -n qpid-test-utils -f .mfiles-qpid-test-utils
%license LICENSE NOTICE

%files tools -f .mfiles-qpid-tools
%doc tools/README.txt

%files javadoc -f .mfiles-javadoc
%license LICENSE NOTICE

%changelog
* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 6.0.4-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 6.0.4-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Wed Jan 04 2017 gil cattaneo <puntogil@libero.it> 6.0.4-5
- fix CVE-2016-8741 (rhbz#1409836,1409835)

* Thu Dec 29 2016 gil cattaneo <puntogil@libero.it> 6.0.4-4
- remove test failure

* Sun Sep 04 2016 gil cattaneo <puntogil@libero.it> 6.0.4-3
- remove test failure

* Mon Aug 22 2016 gil cattaneo <puntogil@libero.it> 6.0.4-2
- remove test failure on ARM builder

* Sat Jul 09 2016 gil cattaneo <puntogil@libero.it> 6.0.4-1
- Initial import (rhbz#1321687)
- update to 6.0.4

* Sat Jun 04 2016 gil cattaneo <puntogil@libero.it> 6.0.3-1
- update to 6.0.3

* Sat Apr 30 2016 gil cattaneo <puntogil@libero.it> 6.0.2-1
- update to 6.0.2

* Tue Mar 15 2016 gil cattaneo <puntogil@libero.it> 6.0.1-1
- initial rpm
